/*
 * hello.c: A plugin for the Video Disk Recorder
 *
 * See the README file for copyright information and how to reach the author.
 *
 * $Id: channelsort.c 4.1 2018/04/10 13:00:22 kls Exp $
 */

#include "channelsort.h"
#include "setup.h"
#include "sorter.h"

#include <getopt.h>
#include <stdlib.h>
#include <vdr/i18n.h>
#include <vdr/plugin.h>

cPluginChannelSort::cPluginChannelSort(void)
{
  // Initialize any member variables here.
  // DON'T DO ANYTHING ELSE THAT MAY HAVE SIDE EFFECTS, REQUIRE GLOBAL
  // VDR OBJECTS TO EXIST OR PRODUCE ANY OUTPUT!
}

cPluginChannelSort::~cPluginChannelSort()
{
  // Clean up after yourself!
}

const char *cPluginChannelSort::CommandLineHelp(void)
{
  // Return a string that describes all known command line options.
  return NULL;
}

bool cPluginChannelSort::ProcessArgs(int argc, char *argv[])
{
  // Implement command line argument processing here if applicable.
  return true;
}

bool cPluginChannelSort::Start(void)
{
  // Start any background activities the plugin shall perform.
  if (AutoSort == true)
    cSorter::Init();
  return true;
}

void cPluginChannelSort::Housekeeping(void)
{
  // Perform any cleanup or other regular tasks.
}

/*cOsdObject *cPluginChannelSort::MainMenuAction(void)
{ 
  // Perform the action when selected from the main VDR menu.
  cSorter::Restart();
  return NULL;
}*/

cMenuSetupPage *cPluginChannelSort::SetupMenu(void)
{
  // Return a setup menu in case the plugin supports one.
  return new cMenuSetupChannelSort;
}

bool cPluginChannelSort::SetupParse(const char *Name, const char *Value)
{
  // Parse your own setup parameters and store their values.
       if (!strcasecmp(Name, "SortMode0"))         SortMode[0] = atoi(Value);
  else if (!strcasecmp(Name, "SortMode1"))         SortMode[1] = atoi(Value);
  else if (!strcasecmp(Name, "SortMode2"))         SortMode[2] = atoi(Value);
  else if (!strcasecmp(Name, "SortMode3"))         SortMode[3] = atoi(Value);
  else if (!strcasecmp(Name, "SortMode4"))         SortMode[4] = atoi(Value);
  else if (!strcasecmp(Name, "AutoSort"))          AutoSort = atoi(Value);
  else if (!strcasecmp(Name, "Reverse"))           Reverse = atoi(Value);
  else if (!strcasecmp(Name, "DeleteInvalid"))     DeleteInvalid = atoi(Value);
  else if (!strcasecmp(Name, "FixedOffset0"))      FixedOffset[0] = atoi(Value);
  else if (!strcasecmp(Name, "FixedOffset1"))      FixedOffset[1] = atoi(Value);
  else if (!strcasecmp(Name, "AutoGroup"))         AutoGroup = atoi(Value);
  else if (!strcasecmp(Name, "AdvancedConfig"))    AdvancedConfig = atoi(Value);

  else
    return false;
  return true;
}

const char** cPluginChannelSort::SVDRPHelpPages(void)
{
  static const char *HelpPages[] = {
    "SORT\n"
    "    Sort channels.",
    NULL
    };
  return HelpPages; 
}

#define cmd(x) (strcasecmp(Command, x) == 0)

cString cPluginChannelSort::SVDRPCommand(const char *Command, const char *Option, int &ReplyCode)
{
  if cmd("SORT")
  {
    sscanf(Option, "%d:%d:%d",
      &SortMode[0],
      &SortMode[1],
      &SortMode[2]);
    cSorter::Restart();
    return "Sorting channels";
  }

  return NULL;
}

VDRPLUGINCREATOR(cPluginChannelSort); // Don't touch this!
