#include <vdr/interface.h>

#include "channelsort.h"
#include "setup.h"
#include "sorter.h"

int SortMode[] {1,2,3,4,5};
bool AutoSort = false;
bool Reverse = false;
bool DeleteInvalid = false;
int FixedOffset[] = {1,2};
bool AutoGroup = false;
bool AdvancedConfig = false;

cMenuSetupChannelSort::cMenuSetupChannelSort(void)
{
  sortModesTexts[0] = tr("none");
  sortModesTexts[1] = tr("type");
  sortModesTexts[2] = tr("frequency");
  sortModesTexts[3] = tr("service ID");
  sortModesTexts[4] = tr("number");
  sortModesTexts[5] = tr("name");
  sortModesTexts[6] = tr("provider");
  newSortMode[0] = SortMode[0];
  newSortMode[1] = SortMode[1];
  newSortMode[2] = SortMode[2];
  newSortMode[3] = SortMode[3];
  newSortMode[4] = SortMode[4];
  newAutoSort = AutoSort;
  newReverse = Reverse;
  newDeleteInvalid = DeleteInvalid;
  newFixedOffset[0] = FixedOffset[0];
  newFixedOffset[1] = FixedOffset[1];
  newAutoGroup = AutoGroup;
  newAdvancedConfig = AdvancedConfig;
  Add(new cMenuEditStraItem( tr("Sort by - 1"), &newSortMode[0], 7, sortModesTexts));
  Add(new cMenuEditStraItem( tr("Sort by - 2"), &newSortMode[1], 7, sortModesTexts));
  Add(new cMenuEditStraItem( tr("Sort by - 3"), &newSortMode[2], 7, sortModesTexts));
  Add(new cMenuEditStraItem( tr("Sort by - 4"), &newSortMode[3], 7, sortModesTexts));
  Add(new cMenuEditStraItem( tr("Sort by - 5"), &newSortMode[4], 7, sortModesTexts));
  Add(new cMenuEditBoolItem( tr("Auto sorting"), &newAutoSort));
  Add(new cMenuEditBoolItem( tr("Reverse sorting"), &newReverse));
  Add(new cMenuEditBoolItem( tr("Delete invalid channels"), &newDeleteInvalid));
  Add(new cMenuEditIntItem( tr("Fixed channels offset - 1"), &newFixedOffset[0]));
  Add(new cMenuEditIntItem( tr("Fixed channels offset - 2"), &newFixedOffset[1]));
  Add(new cMenuEditBoolItem( tr("Auto grouping"), &newAutoGroup));
  Add(new cMenuEditBoolItem( tr("Use advanced config file"), &newAdvancedConfig));
  SetHelp( tr("Sort"), "");
}

void cMenuSetupChannelSort::Store(void)
{
  SetupStore("SortMode0", SortMode[0] = newSortMode[0]);
  SetupStore("SortMode1", SortMode[1] = newSortMode[1]);
  SetupStore("SortMode2", SortMode[2] = newSortMode[2]);
  SetupStore("SortMode3", SortMode[3] = newSortMode[3]);
  SetupStore("SortMode4", SortMode[4] = newSortMode[4]);
  SetupStore("AutoSort", AutoSort = newAutoSort);
  SetupStore("Reverse", Reverse = newReverse);
  SetupStore("DeleteInvalid", DeleteInvalid = newDeleteInvalid);
  SetupStore("FixedOffset0", FixedOffset[0] = newFixedOffset[0]);
  SetupStore("FixedOffset1", FixedOffset[1] = newFixedOffset[1]);
  SetupStore("AutoGroup", AutoGroup = newAutoGroup);
  SetupStore("AdvancedConfig", AdvancedConfig = newAdvancedConfig);
}

eOSState cMenuSetupChannelSort::ProcessKey(eKeys Key)
{
  eOSState state = cOsdMenu::ProcessKey(Key);
  if (state == osUnknown)
  {
    switch(Key)
    {
      case kOk:
        Store();
        state = osBack;
        break;
      case kRed:
        Store();
        //state = osBack;
        cSorter::Restart();
        Interface->Confirm(tr("Sorting channels"));
        break;
      default:
        break;
    }
  }
  return state;
}
