#include <vdr/channels.h>
#include <vdr/thread.h>
#include <map>
#include <string>

#define LCN_OVERFLOW_OFFSET 1024

class cFixedChannels : public cConfig<cChannel> {
public:
  cFixedChannels(const cString& FixedChannelsFile) {
    Load(FixedChannelsFile, true, true);
  }
};

class cSorter : public cThread {
private:
  bool s_Active;
  static cSorter *s_Instance;
  bool CheckInvalid(cChannel *ch);
  int Compare(cChannel *ch1, cChannel *ch2);
  int CheckFixedNumber(cChannel *ch1, cFixedChannels temps);
  void Sort();
  void UpdateGroupingMap(cChannel *ch, std::map<char*, cChannel*> &map);
  int StringInsensitiveSubstring(std::string str1, std::string str2);
protected:
  virtual void Action(void);
  void Stop(void);
public:
  cSorter();
  virtual ~cSorter();
  static void Init(void);
  static void Exit(void);
  static void Restart(void);
};
